<script setup lang="ts">
import type { DataTableColumns } from 'naive-ui'
import { NButton, useMessage } from 'naive-ui'
import type { IProperty } from 'types/tags'
import type { PropType, Ref } from 'vue'

interface PropertyColumns {
  label: string
  property: string
  type: string
  location: string
}

const props = defineProps({
  copyNamespace: {
    type: String,
    required: true,
  },
  labelNamespace: {
    type: String,
    required: true,
  },
  modelValue: {
    type: Array as PropType<IProperty[]>,
    default: () => [],
  },
})
const emit = defineEmits(['update:modelValue'])
const message = useMessage()
const { isSupported, copy } = useClipboard()

const propertyData = computed({
  get() {
    return props.modelValue
  },
  set(value) {
    emit('update:modelValue', value)
  },
})
const propertyHeader = computed(() => {
  return props.labelNamespace
})
const copiedIndex: Ref<number | null> = ref(null)

// Methods
const createColumns = ({ copyProperty }: {
  copyProperty: (row: PropertyColumns, index: number) => void
}): DataTableColumns<PropertyColumns> => {
  return [
    {
      title: '',
      key: 'copy',
      align: 'center',
      width: 50,
      render(row, index) {
        return isSupported
          ? h(
            NButton,
            {
              text: true,
              size: 'small',
              title: 'Copy this Tag',
              class: 'flex flex-col items-center justify-center',
              innerHTML: '<i role="img" class="i-ant-design:copy-outlined block h-4 w-4" />',
              onClick: () => {
                copyProperty(row, index)
              },
            },
          )
          : undefined
      },
    },
    {
      title: 'Label',
      key: 'label',
      sorter: 'default',
      renderSorterIcon: ({ order }) => {
        if (order === false)
          return h('div', { class: 'n-data-table-sorter', innerHTML: '<i role="img" class="i-ant-design:minus-outlined n-base-icon" />' })
        if (order === 'ascend')
          return h('div', { class: 'n-data-table-sorter', innerHTML: '<i role="img" class="i-ant-design:arrow-down-outlined n-base-icon" />' })
        if (order === 'descend')
          return h('div', { class: 'n-data-table-sorter', innerHTML: '<i role="img" class="i-ant-design:arrow-down-outlined n-base-icon" />' })
      },
      ellipsis: {
        tooltip: true,
      },
    },
    {
      title: 'Property',
      key: 'property',
      sorter: 'default',
      renderSorterIcon: ({ order }) => {
        if (order === false)
          return h('div', { class: 'n-data-table-sorter', innerHTML: '<i role="img" class="i-ant-design:minus-outlined n-base-icon" />' })
        if (order === 'ascend')
          return h('div', { class: 'n-data-table-sorter', innerHTML: '<i role="img" class="i-ant-design:arrow-down-outlined n-base-icon" />' })
        if (order === 'descend')
          return h('div', { class: 'n-data-table-sorter', innerHTML: '<i role="img" class="i-ant-design:arrow-down-outlined n-base-icon" />' })
      },
      ellipsis: {
        tooltip: true,
      },
    },
    {
      title: 'Data Type',
      key: 'type',
    },
    {
      title: 'Location in Platform',
      key: 'location',
      ellipsis: {
        tooltip: true,
      },
    },
  ]
}

// Initialize the Data Table
const columns = createColumns({
  copyProperty(row: PropertyColumns, index: number) {
    const fullPlaceholder = `${props.copyNamespace}.${row.property}`
    copy(fullPlaceholder)
    copiedIndex.value = index
    message.info('Copied ' + fullPlaceholder)
  },
})
</script>

<template>
  <div>
    <n-divider title-placement="center" class="!m-0 px-2 pt-2 text-arctic-50 font-semibold bg-arctic">
      {{ propertyHeader || "Namespace" }}
    </n-divider>
    <n-data-table
      :bordered="false"
      :columns="columns"
      :data="propertyData"
      style="--n-merged-th-color: #00263A; --n-th-text-color: #e6e9eb; --n-merged-th-color-hover:rgba(26, 60, 78, 0.9); max-height: 60vh; min-height: 60vh;"
    >
      <template #empty>
        <div v-if="copyNamespace === ''" class="flex flex-col items-center justify-center space-y-lg">
          <i role="img" class="i-ant-design:arrow-left-outlined block w-12 h-12 text-pacific" />
          <span class="text-lg">Select a namespace to see its properties</span>
        </div>
        <div v-else class="flex flex-col items-center justify-center space-y-lg">
          <span class="text-lg">There are no properties for this namespace</span>
        </div>
      </template>
    </n-data-table>
  </div>
</template>

